<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Task 29.170</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  </head>
  <html>
    <body onload="onPageLoading()">
      <div class="container">
        <h2 class="text-center">Hãy tạo bảng dữ liệu nhân viên</h2>
        <table
          id="user-table"
          class="table table-bordered table-striped table-hover"
        >
          <thead>
            <tr>
              <th>Id</th>
              <th>Firstname</th>
              <th>Lastname</th>
              <th>Photo</th>
            </tr>
          </thead>
          <tbody></tbody>
        </table>
      </div>
    </body>
    <script>
      "use strict";
      // đây là dữ liệu dùng tạo bảng
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      var gEmployeeList = `{
        "employees": {
            "employee": [
            {
                "id": "1",
                "firstName": "Tom",
                "lastName": "Cruise",
                "photo": "https://jsonformatter.org/img/tom-cruise.jpg"
            },
            {
                "id": "2",
                "firstName": "Maria",
                "lastName": "Sharapova",
                "photo": "https://jsonformatter.org/img/Maria-Sharapova.jpg"
            },
            {
                "id": "3",
                "firstName": "Robert",
                "lastName": "Downey Jr.",
                "photo": "https://jsonformatter.org/img/Robert-Downey-Jr.jpg"
            }
            ]
        }
        }`;

      // parsing json to object
      var gEMLOYEE_LIST_OBJECT = JSON.parse(gEmployeeList);
      var gEmployeeObj = gEMLOYEE_LIST_OBJECT.employees.employee;
      const gEND_ROW_TABLE = -1;
      // hằng số số thứ tự các cột
      const gCOLUMN_USER_ID = 0;
      const gCOLUMN_FIRSTNAME = 1;
      const gCOLUMN_LASTNAME = 2;
      const gCOLUMN_PHOTO = 3;

      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
      $(document).ready(function () {
        onPageLoading();

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        // hàm xử lý sự kiện loading
        function onPageLoading() {
          console.log(gEmployeeObj);
          // hiển thị dữ liệu lên table
          showDataOnTable(gEmployeeObj);
        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
        // hiển thị dữ liệu lên table
        function showDataOnTable(paramUserList) {
          var vTable = document.getElementById("user-table");
          var vTableBody = vTable.getElementsByTagName("tbody")[0];

          for (var bIndex = 0; bIndex < paramUserList.length; bIndex++) {
            var vUser = paramUserList[bIndex];
            // tạo dòng mưới cho bẳng và ghi vào các giá trị
            var row = vTableBody.insertRow(-1);

            var vCellUserId = row.insertCell(gCOLUMN_USER_ID);
            var vCellFirstname = row.insertCell(gCOLUMN_FIRSTNAME);
            var vCellLastname = row.insertCell(gCOLUMN_LASTNAME);
            var vCellPhoto = row.insertCell(gCOLUMN_PHOTO);

            vCellUserId.innerHTML = vUser.id;
            vCellFirstname.innerHTML = vUser.firstName;
            vCellLastname.innerHTML = vUser.lastName;
            var vPhoto = vUser.photo;
            var vShow = "<img" + " src=" + vPhoto + " alt=''>";
            vCellPhoto.innerHTML = vShow;
          }
        }
      });
    </script>
  </html>
</html>
